<?php
/*****************************************************************************/
/* QueryString.php                                                           */
/*****************************************************************************/
/* YaBB: Yet another Bulletin Board                                          */
/* Open-Source Project started by Zef Hemel (zef@zefnet.com)                 */
/* Software Version: YaBB SE                                                 */
/* ========================================================================= */
/* Software Distributed by:    http://www.yabbse.org                         */
/* Support, News, Updates at:  http://www.yabbse.org/community               */
/*                             http://www.yabbforum.com/community            */
/* ========================================================================= */
/* Copyright (c) 2001-2002 The YaBB SE Development Team                      */
/* Software by: The YaBB SE Development Team                                 */
/*****************************************************************************/
/* This program is free software; you can redistribute it and/or modify it   */
/* under the terms of the GNU General Public License as published by the     */
/* Free Software Foundation; either version 2 of the License, or (at your    */
/* option) any later version.                                                */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General */
/* Public License for more details.                                          */
/*                                                                           */
/* The GNU GPL can be found in gpl.txt in this directory                     */
/*****************************************************************************/

if (strlen($QUERY_STRING)>0)
{
	$str = (substr($QUERY_STRING,0,5) == "url=/")?$HTTP_SERVER_VARS["REDIRECT_QUERY_STRING"]:$QUERY_STRING;
	$query_strings = split("[;&]",URLdecode($str));
	foreach ($query_strings as $tmp)
	{
		if (preg_match("/^([^=]+)[=](.*)/", $tmp, $parts))
			$GLOBALS[$parts[1]] = $parts[2];
	}

	$REMOTE_ADDR = ($HTTP_X_FORWARDED_FOR != '' ? $HTTP_X_FORWARDED_FOR : $REMOTE_ADDR);
	$REMOTE_ADDR = ($HTTP_CLIENT_IP != '' ? $HTTP_CLIENT_IP: $REMOTE_ADDR);
}
?>