<?php
/*****************************************************************************/
/* Register.php                                                              */
/*****************************************************************************/
/* YaBB: Yet another Bulletin Board                                          */
/* Open-Source Project started by Zef Hemel (zef@zefnet.com)                 */
/* Software Version: YaBB SE                                                 */
/* ========================================================================= */
/* Software Distributed by:    http://www.yabbse.org                         */
/* Support, News, Updates at:  http://www.yabbse.org/community               */
/*                             http://www.yabbforum.com/community            */
/* ========================================================================= */
/* Copyright (c) 2001-2002 The YaBB SE Development Team                      */
/* Software by: The YaBB SE Development Team                                 */
/*****************************************************************************/
/* This program is free software; you can redistribute it and/or modify it   */
/* under the terms of the GNU General Public License as published by the     */
/* Free Software Foundation; either version 2 of the License, or (at your    */
/* option) any later version.                                                */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General */
/* Public License for more details.                                          */
/*                                                                           */
/* The GNU GPL can be found in gpl.txt in this directory                     */
/*****************************************************************************/

$registerphpver = 'YaBB SE 1.5.0';

function Register ()
{
	global $yytitle, $txt, $color, $cgi, $action, $allow_hide_email, $modSettings, $RegAgree, $emailpassword, $vardir, $db_prefix;

	$yytitle = $txt[97];
	template_header();

	echo '
		<script language="javascript" type="text/javascript">
		<!--
		var checkobj
		function agreesubmit(el){
			checkobj=el
			if (document.all||document.getElementById){
				for (i=0;i<checkobj.form.length;i++){  //hunt down submit button
					var tempobj=checkobj.form.elements[i]
					if(tempobj.type.toLowerCase()=="submit")
					tempobj.disabled=!checkobj.checked
				}
			}
		}
		function defaultagree(el){
			if (!document.all&&!document.getElementById){
				if (window.checkobj&&checkobj.checked)
				return true
			else{
				alert("Please read/accept terms to submit form")
				return false
				}
			}
		}
		// -->
		</script>
		<form action="' . $cgi . ';action=register2" method="post" name="creator" onsubmit="return defaultagree(this)">
			<table border="0" width="100%" cellspacing="1" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" cellpadding="2">
				<tr>
					<td class="titlebg" bgcolor="' . $color['titlebg'] . '">
						<font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $txt[97] . '</b> ' . $txt[517] . '</font>
					</td>
				</tr><tr>
					<td class="windowbg" bgcolor="' . $color['windowbg'] . '" width="100%">
						<table cellpadding="3" cellspacing="0" border="0" width="100%">
							<tr>
								<td width="40%">
									<font size="2">* <b>' . $txt[98] . ':</b></font><br />
									<font size="1">' . $txt[520] . '</font>
								</td>
								<td>
									<input type="text" name="user" size="20" maxlength="18" />
								</td>
							</tr><tr>
								<td width="40%">
									<font size="2">* <b>' . $txt[69] . ':</b></font><br />
									<font size="1">' . $txt[679] . '</font>
								</td>
								<td>';

	if ($allow_hide_email == 1)
		echo '<font size="2"><input type="text" name="email" size="30" /> <input type="checkbox" name="hideemail" /> ' . $txt[721] . '</font>';
	else
		echo '<input type="text" name="email" size="30" /><br /><font size="1">' . $txt[679] . '</font>';

	echo '
								</td>
							</tr>';

	if ( $emailpassword == '')
		echo '
							<tr>
								<td width="40%"><font size="2">* <b>' . $txt[81] . ':</b></font></td>
								<td><font size="2"><input type="password" name="passwrd1" size="30" /></font></td>
							</tr><tr>
								<td width="40%"><font size="2">* <b>' . $txt[82] . ':</b></font></td>
								<td><font size="2"><input type="password" name="passwrd2" size="30" /></font></td>
							</tr>';

	echo '
						</table>
					</td>
				</tr>
			</table>';

	if ($RegAgree)
	{
		$request = mysql_query("SELECT value FROM {$db_prefix}settings WHERE variable='agreement'");
		$temp = mysql_fetch_row($request);
		$fullagree = nl2br($temp[0]);
		echo '
			<table border="0" cellspacing="1" cellpadding="5" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" width="100%" align="center">
				<tr>
					<td bgcolor="' . $color['windowbg2'] . '" class="windowbg2">
						<font size="2"><br />' . $fullagree . '<br /><br /></font>
					</td>
				</tr><tr>
					<td bgcolor="' . $color[windowbg] . '" align="center" class="windowbg">
						<font size="2">
							<b>' . $txt[585] . '</b> <input name="regagree" type="checkbox" onClick="agreesubmit(this)">&nbsp;&nbsp;
						</font>
					</td>
				</tr>
			</table>';
	}
	$isDisabled = ($RegAgree ? 'disabled="disabled"' : '');
	echo '
			<br />
			<div align="center">
				<input type="submit" value="' . $txt[97] . '" ' . $isDisabled . ' />
			</div>
		</form>
		<script language="javascript" type="text/javascript">
			document.forms.creator.regagree.checked=false
		</script>';

	footer();
	obExit();
}

function Register2 ()
{
	global $HTTP_GET_VARS, $HTTP_POST_VARS, $mbname, $emailwelcome, $Cookie_Length, $emailpassword, $color, $cgi;
	global $hideemail, $yySetLocation, $scripturl, $yyTitle, $txt, $user, $regagree, $db_prefix, $webmaster_email;
	global $allow_hide_email, $modSettings, $REMOTE_ADDR;

	$hideemail = ($allow_hide_email && $hideemail == 'on')?'1':'0';

	if ($regagree == "no")
	{
		header("Location: $scripturl");
		exit();
	}

	$member = array();

	foreach($HTTP_GET_VARS as $key => $value)
		$member[$key] = str_replace("\n", '', str_replace("\r", '', trim($value)));

	foreach($HTTP_POST_VARS as $key => $value)
		$member[$key] = str_replace("\n", '', str_replace("\r", '', trim($value)));

	$request = mysql_query("SELECT moderators FROM {$db_prefix}boards");
	while ($tmp = mysql_fetch_array($request)) {
		$moderators = explode(',', $tmp['moderators']);
		if (in_array($member['user'], $moderators)) 
			fatal_error($txt['yse289']);
	}

	if (strlen($member['user']) > 25) 
		$member['user'] = substr($member['user'], 0, 25);

	if ($member['user'] == '')
		fatal_error(htmlspecialchars ($member[user])." $txt[37]");

	if (!preg_match("/^[\s0-9A-Za-z#,-\.:=?@^_]+$/",$user))
		fatal_error($txt[240]);

	if ($member['user'] == '_' || $member['user'] == '|')
		fatal_error(htmlspecialchars($member['user']) . " $txt[99]");

	if (strstr($member['user'], 'Guest'))
		fatal_error("$txt[244] " . htmlspecialchars($member['user']));

	if (!eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$", $member['email']))
		fatal_error("$member[user] $txt[500]");

	if ($member['email'] == '')
		fatal_error(htmlspecialchars($member[user])." $txt[76]");

	$request = mysql_query("SELECT ID_MEMBER FROM {$db_prefix}members WHERE memberName='$member[user]'");
	if (mysql_num_rows($request) > 0)
		fatal_error('(' . htmlspecialchars($member['user']) . ") $txt[100]");

	if ($emailpassword)
	{
		// randomly generate a new password
		mt_srand(time());
		$password = crypt(mt_rand(-100000, 100000));      

		// remove all non alpha-numeric characters
		$password = preg_replace("/\W/", '', $password);

		// limit it to 10 characters max
		$member['passwrd1']= substr($password, 0, 10);
	}
	else
	{
		if ($member['passwrd1'] !=  $member['passwrd2'])
			fatal_error('(' . htmlspecialchars($member['user']) . ") $txt[213]");

		if ($member['passwrd1'] == '')
			fatal_error('(' . htmlspecialchars($member['user']) . ") $txt[91]");
	}

	$request = mysql_query ("SELECT value FROM {$db_prefix}banned WHERE (type='email' && value='$member[email]')");
	if (mysql_num_rows($request) > 0)
		fatal_error("$txt[678]$txt[430]!");

	// Check if the email address  or the username is in use
	$request = mysql_query("SELECT realName FROM {$db_prefix}members WHERE emailAddress='$member[email]'");
	if (mysql_num_rows($request) > 0)
		fatal_error("$txt[730] (" . htmlspecialchars($member[email]) . ") $txt[731]");

	$request = mysql_query("SELECT realName FROM {$db_prefix}members WHERE (memberName='$member[user]' || realName='$member[user]')");
	if (mysql_num_rows($request) > 0)
		fatal_error('(' . htmlspecialchars($member['user']) . ") $txt[473]");

	htmlentities($member['email']);

	$request = mysql_query("SELECT setting,value FROM {$db_prefix}reserved_names WHERE 1");
	if (mysql_num_rows($request) > 0)
	{
		$reserve = array();
		while ($row = mysql_fetch_array($request))
		{
			if ($row['setting'] == 'word')
				$reserve[] = trim($row['value']);
			else
				${$row['setting']} = trim($row['value']);
		}

		$namecheck = ($matchcase == '1' ? $member['user'] : strtolower($member['user']));

		foreach ($reserve as $reserved)
		{
			$reservecheck = ($matchcase == '1') ? $reserved : strtolower($reserved);
			if ($matchuser == '1')
			{
				if ($matchword == '1')
				{
					if ($namecheck == $reservecheck)
						fatal_error("$txt[244] $reserved");
				}
				else
				{
					if (strstr($namecheck,$reservecheck))
						fatal_error("$txt[244] $reserved");
				}
			}
		}
	}

	$request = mysql_query("SELECT ID_MEMBER FROM {$db_prefix}members WHERE memberName='$member[user]'");
	if (mysql_num_rows($request) > 0)
		fatal_error($txt[100]);

	$requesttime = time();

	$queryPasswdPart = crypt($member['passwrd1'], substr($member['passwrd1'], 0, 2));

	$memIP = $REMOTE_ADDR;
	$request = mysql_query("
		INSERT INTO {$db_prefix}members (memberName,realName,passwd,emailAddress,posts,personalText,avatar,dateRegistered,hideEmail,memberIP,im_email_notify)
		VALUES ('$member[user]','$member[user]','$queryPasswdPart','$member[email]',0,'" . mysql_escape_string($txt[209]) ."','blank.gif',$requesttime,'$hideemail','$memIP',1)");
	print mysql_error();
	updateStats('member');

	if ($modSettings['trackStats'] == 1)
	{
		$date = getdate(time());
		$statsquery = mysql_query("UPDATE {$db_prefix}log_activity SET registers = registers + 1 WHERE month = $date[mon] AND day = $date[mday] AND year = $date[year]");
		if (mysql_affected_rows() == 0)
			$statsquery = mysql_query("INSERT INTO {$db_prefix}log_activity (month, day, year, registers) VALUES ($date[mon], $date[mday], $date[year], 1)");
	}

	$yytitle = $txt[245];
	template_header();


	if ( $emailpassword )
	{
		sendmail($member['email'], "$txt[700] $mbname", "$txt[248] $member[user]!\n\n$txt[719] $member[user]\n\n$txt[492] $member[passwrd1]\n\n$txt[701]\n$scripturl?action=profile;user=$member[user]\n\n$txt[130]",$webmaster_email);

		echo '
			<br />
			<table border="0" width="100%" cellspacing="1" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" align="center">
				<tr>
					<td class="titlebg" bgcolor="' . $color['titlebg'] . '"><font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $txt[97] . '</b></font></td>
				</tr><tr>
					<td class="windowbg" bgcolor="' . $color['windowbg'] . '" align="left" cellpadding=3><font size="2">' . $txt[703] . '</font></td>
				</tr><tr>
					<td class="windowbg" bgcolor="' . $color['windowbg'] . '" valign="top">
						<form action="' . $cgi . ';action=login2" method="post">
							<table border="0" cellpadding="0" cellspacing="0">
								<tr>
									<td><font size="2"><b>' . $txt[35] . ':</b></font></td>
									<td><font size="2"><input type="text" name="user" size="15" value="' . $member['user'] . '" /></font></td>
									<td><font size="2"><b>' . $txt[36] . ':</b></font></td>
									<td><font size="2"><input type=password name="passwrd" size="10" /></font> &nbsp;</td>
									<td><font size="2"><b>' . $txt[497] . ':</b></font></td>
									<td><font size="2"><input type="text" name="cookielength" size=4 value="' . $Cookie_Length . '" />
									<td><font size="2"><b>' . $txt[508] . ':</b></font></td>
									<td><font size="2"><input type="checkbox" name="cookieneverexp" /></font></td> &nbsp;</font></td>
									<td align="center" colspan="2"><input type="submit" value="' . $txt[34] . '" /></td>
								</tr>
							</table>
						</form>
					</td>
				</tr>
			</table>';
		EOT;
	}
	else
	{
		if ( $emailwelcome )
		{
			$euser=urlencode($member['user']);
			sendmail($member['email'], "$txt[700] $mbname", "$txt[248] $member[user]!\n\n$txt[719] $member[user], $txt[492] $member[passwrd1]\n\n$txt[701]\n$scripturl?action=profile;user=$euser\n\n$txt[130]", $webmaster_email);
		}
		echo '
			<br /><br /><br />
			<div="center"><font size="2">' . $txt[431] . '</font></div>
			<br /><br />
			<table border="0" width=300 cellspacing="1" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" align="center">
				<tr>
					<td class="titlebg" bgcolor="' . $color['titlebg'] . '"><font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $txt[97] . '</b></font></td>
				</tr><tr>
					<td class="windowbg" bgcolor="' . $color['windowbg'] . '" align="center">
						<font size="2">
							<form action="' . $cgi . ';action=login2" method="post">
								<input type="hidden" name="user" value="' . $member['user'] . '" />
								<input type="hidden" name="passwrd" value="' . $member['passwrd1'] . '" />
								<input type="hidden" name="cookielength" value="' . $Cookie_Length . '" />
								<input type="submit" value="' . $txt[34] . '" />
							</form>
						</font>
					</td>
				</tr>
			</table>';
	}

	footer();
	obExit();
}

?>
